//-----------------------------------------------------------
/*
 Program    :- PortExpanderPCF.h_Testing_Code.
 Author     :- LK.Perera
 Controller :- PIC16F887
 Date       :- 2019.04.30
 Program.No :- ---
*/
//-----------------------------------------------------------
/*
Notes/Mentions :-
->This header file can be used to control both of the PCF8574/8575 Chips.
->There up to 8 chips can be connected to one Microchip.
->Both functions can be use for both chips by adjesting the Slave adresses.
->PCF8574 is 8-bit and PCF8575 is 16-bit GPIO Expanders and when you use PCF8575 it should adress both 8-bit registers separatly.
-> To use the header use #include<PortExpanderPCF.h> before the main() function.
-> Use Project > Add Existing file > Select the header path in MikroC ide to add the header file to the main project.
-> This functions use built-in I2C library.So initialize I2C library in your main project to avoid program crashes.
-> Default slave adress is 
*/
//-----------------------------------------------------------
//All the Source code contains are own by the authour.All rights reserved.
//-----------------------------------------------------------
#include<PortExpanderPCF.h>//Including the header file.
//---------------------------END-OF-SOURCE-CODE------------------
void main(){
ANSEL = 0;//Set all GPIO in Digital.
ANSELH = 0;//Set all GPIO in Digital.
C1ON_bit = 0;//Disable Comparator 1.
C2ON_bit = 0;//Disable Comparator 2.
TRISA = 0x00;//Assign TRISA as Output.
TRISB = 0x00;//Assign TRISB as Output.
TRISD = 0x00;//Assign TRISD as Output.
PORTA = 0x00;//Assign PORTA as Output.
PORTB = 0x00;//Assign PORTB as Output.
PORTD = 0x00;//Assign PORTD as Output.
I2C1_Init(100000);//Initializing I2C function.
PCF8574_Exp_Out(0);//Firts Make all the GPIO to low.Use custom value inside the bracket.
PCF8575_Exp_Out(0,0);//Firts Make all the GPIO to low.Two integer value for each 8-bit registers.
//While loop used as program loop.
while(1){
  PCF8574_Exp_In();//Custom function for PCF8574.
  PORTA = PortValue_;//Assign PortValue_ to PORTA Register.
  PCF8574_Exp_Out(15);//Built-in function for PCF8574.
  PCF8575_Exp_In();//Buit-in function for PCF8575.
  PORTB = PortValue_A;//Assign PortValue_A to PORTB Register.
  PORTD = PortValue_B;//Assign PortValue_B to PORTD Register.
 }
//---------------------------END-OF-SOURCE-CODE------------------
}