//-----------------------------------------------------------
/*
 Program    :- PortExpanderPCF_v1.0.h
 Author     :- LK.Perera
 Controller :- PIC16F887
 Date       :- 2019.04.30
 Program.No :- ---
*/
//-----------------------------------------------------------
/*
Notes/Mentions :-
->This header file can be used to control both of the PCF8574/8575 Chips.
->There up to 8 chips can be connected to one Microchip.
->Both functions can be use for both chips by adjesting the Slave adresses.
->PCF8574 is 8-bit and PCF8575 is 16-bit GPIO Expanders and when you use PCF8575 it should adress both 8-bit registers separatly.
-> To use the header use #include<PortExpanderPCF.h> before the main() function.
-> Use Project > Add Existing file > Select the header path in MikroC ide to add the header file to the main project.
-> This functions use built-in I2C library.So initialize I2C library in your main project to avoid program crashes.
-> Default slave adress is 
*/
//-----------------------------------------------------------
//All the Source code contains are own by the authour.All rights reserved.
//-----------------------------------------------------------
//This function controls GPIO of the PCF8574 8bit GPIO.
int PortValue_=0;//This variable for reading purposes.
int PortValue_A=0;//This variable for reading purposes.
int PortValue_B=0;//This variable for reading purposes.
//-------------------------------------------------------PCF8574-------
//This function controls GPIO the PCF8574 8bit GPIO.
void PCF8574_Exp_Out(int PortValue_){
  I2C_Start();//I2C start function.
  I2C_Write(0x40);//Setting the Slave Address for PCF8574.
  I2C_Write(PortValue_);//Custom value for GPIO.
  I2C_Stop();//I2C stop function.
}
//This function controls GPIO the PCF8574 8bit GPIO.
void PCF8574_Exp_In(){
  I2C_Start();//I2C start function.
  I2C_Write(0x41);//Setting the Slave Address for PCF8574.
  PortValue_=I2C_Read(0);//Read from slave without Ack.
  I2C_Stop();//I2C stop function.
}
//-------------------------------------------------------PCF8575-------
//This function controls GPIO the PCF8575 16bit GPIO.
void PCF8575_Exp_Out(int PortValue_A, int PortValue_B){
 I2C_Start();//I2C start function.
 I2C_Write(0x44);//Setting the Slave Address for PCF8575.
 I2C_Write(PortValue_A);//Custom value for first 8bits.
 I2C_Write(PortValue_B);//Custom value for second 8bits.
 I2C_Stop();//I2C stop function.
}
//This function controls GPIO the PCF8575 16bit GPIO.
void PCF8575_Exp_In(){
  I2C_Start();//I2C start function.
  I2C_Write(0x45);//Setting the Slave Address for PCF8574.
  PortValue_A=I2C_Read(1);//Read from slave with Ack.
  PortValue_B=I2C_Read(0);//Read from slave without Ack.
  I2C_Stop();//I2C stop function.
}
//---------------------------END-OF-SOURCE-CODE------------------
